diff --git a/src/backend/access/common/tupdesc.c b/src/backend/access/common/tupdesc.c
index 1f40b7c..5fe1710 100644
--- a/src/backend/access/common/tupdesc.c
+++ b/src/backend/access/common/tupdesc.c
@@ -339,8 +339,6 @@ equalTupleDescs(TupleDesc tupdesc1, TupleDesc tupdesc2)
 			return false;
 		if (attr1->atttypid != attr2->atttypid)
 			return false;
-		if (attr1->attstattarget != attr2->attstattarget)
-			return false;
 		if (attr1->attlen != attr2->attlen)
 			return false;
 		if (attr1->attndims != attr2->attndims)
@@ -473,7 +471,6 @@ TupleDescInitEntry(TupleDesc desc,
 	else
 		MemSet(NameStr(att->attname), 0, NAMEDATALEN);
 
-	att->attstattarget = -1;
 	att->attcacheoff = -1;
 	att->atttypmod = typmod;
 
diff --git a/src/backend/access/nbtree/nbtcompare.c b/src/backend/access/nbtree/nbtcompare.c
index fedde93..c5a9474 100644
--- a/src/backend/access/nbtree/nbtcompare.c
+++ b/src/backend/access/nbtree/nbtcompare.c
@@ -308,6 +308,30 @@ btoidvectorcmp(PG_FUNCTION_ARGS)
 }
 
 Datum
+btint2vectorcmp(PG_FUNCTION_ARGS)
+{
+	int2vector  *a = (int2vector *) PG_GETARG_POINTER(0);
+	int2vector  *b = (int2vector *) PG_GETARG_POINTER(1);
+	int			i;
+
+	/* We arbitrarily choose to sort first by vector length */
+	if (a->dim1 != b->dim1)
+		PG_RETURN_INT32(a->dim1 - b->dim1);
+
+	for (i = 0; i < a->dim1; i++)
+	{
+		if (a->values[i] != b->values[i])
+		{
+			if (a->values[i] > b->values[i])
+				PG_RETURN_INT32(1);
+			else
+				PG_RETURN_INT32(-1);
+		}
+	}
+	PG_RETURN_INT32(0);
+}
+
+Datum
 btcharcmp(PG_FUNCTION_ARGS)
 {
 	char		a = PG_GETARG_CHAR(0);
diff --git a/src/backend/bootstrap/bootstrap.c b/src/backend/bootstrap/bootstrap.c
index e3ae92d..bde0285 100644
--- a/src/backend/bootstrap/bootstrap.c
+++ b/src/backend/bootstrap/bootstrap.c
@@ -737,7 +737,6 @@ DefineAttr(char *name, char *type, int attnum)
 			attrtypes[attnum]->attndims = 0;
 	}
 
-	attrtypes[attnum]->attstattarget = -1;
 	attrtypes[attnum]->attcacheoff = -1;
 	attrtypes[attnum]->atttypmod = -1;
 	attrtypes[attnum]->attislocal = true;
diff --git a/src/backend/catalog/heap.c b/src/backend/catalog/heap.c
index a8653cd..e3b17e8 100644
--- a/src/backend/catalog/heap.c
+++ b/src/backend/catalog/heap.c
@@ -126,37 +126,37 @@ static List *insert_ordered_unique_oid(List *list, Oid datum);
  */
 
 static FormData_pg_attribute a1 = {
-	0, {"ctid"}, TIDOID, 0, sizeof(ItemPointerData),
+	0, {"ctid"}, TIDOID, sizeof(ItemPointerData),
 	SelfItemPointerAttributeNumber, 0, -1, -1,
 	false, 'p', 's', true, false, false, true, 0
 };
 
 static FormData_pg_attribute a2 = {
-	0, {"oid"}, OIDOID, 0, sizeof(Oid),
+	0, {"oid"}, OIDOID, sizeof(Oid),
 	ObjectIdAttributeNumber, 0, -1, -1,
 	true, 'p', 'i', true, false, false, true, 0
 };
 
 static FormData_pg_attribute a3 = {
-	0, {"xmin"}, XIDOID, 0, sizeof(TransactionId),
+	0, {"xmin"}, XIDOID, sizeof(TransactionId),
 	MinTransactionIdAttributeNumber, 0, -1, -1,
 	true, 'p', 'i', true, false, false, true, 0
 };
 
 static FormData_pg_attribute a4 = {
-	0, {"cmin"}, CIDOID, 0, sizeof(CommandId),
+	0, {"cmin"}, CIDOID, sizeof(CommandId),
 	MinCommandIdAttributeNumber, 0, -1, -1,
 	true, 'p', 'i', true, false, false, true, 0
 };
 
 static FormData_pg_attribute a5 = {
-	0, {"xmax"}, XIDOID, 0, sizeof(TransactionId),
+	0, {"xmax"}, XIDOID, sizeof(TransactionId),
 	MaxTransactionIdAttributeNumber, 0, -1, -1,
 	true, 'p', 'i', true, false, false, true, 0
 };
 
 static FormData_pg_attribute a6 = {
-	0, {"cmax"}, CIDOID, 0, sizeof(CommandId),
+	0, {"cmax"}, CIDOID, sizeof(CommandId),
 	MaxCommandIdAttributeNumber, 0, -1, -1,
 	true, 'p', 'i', true, false, false, true, 0
 };
@@ -168,7 +168,7 @@ static FormData_pg_attribute a6 = {
  * used in SQL.
  */
 static FormData_pg_attribute a7 = {
-	0, {"tableoid"}, OIDOID, 0, sizeof(Oid),
+	0, {"tableoid"}, OIDOID, sizeof(Oid),
 	TableOidAttributeNumber, 0, -1, -1,
 	true, 'p', 'i', true, false, false, true, 0
 };
@@ -595,7 +595,6 @@ InsertPgAttributeTuple(Relation pg_attribute_rel,
 	values[Anum_pg_attribute_attrelid - 1] = ObjectIdGetDatum(new_attribute->attrelid);
 	values[Anum_pg_attribute_attname - 1] = NameGetDatum(&new_attribute->attname);
 	values[Anum_pg_attribute_atttypid - 1] = ObjectIdGetDatum(new_attribute->atttypid);
-	values[Anum_pg_attribute_attstattarget - 1] = Int32GetDatum(new_attribute->attstattarget);
 	values[Anum_pg_attribute_attlen - 1] = Int16GetDatum(new_attribute->attlen);
 	values[Anum_pg_attribute_attnum - 1] = Int16GetDatum(new_attribute->attnum);
 	values[Anum_pg_attribute_attndims - 1] = Int32GetDatum(new_attribute->attndims);
@@ -667,12 +666,13 @@ AddNewAttributeTuples(Oid new_rel_oid,
 		attr = tupdesc->attrs[i];
 		/* Fill in the correct relation OID */
 		attr->attrelid = new_rel_oid;
-		/* Make sure these are OK, too */
-		attr->attstattarget = -1;
+		/* Make sure this is OK, too */
 		attr->attcacheoff = -1;
 
 		InsertPgAttributeTuple(rel, attr, indstate);
 
+		AddStatistics(new_rel_oid, &attr->attnum, 1, (oidinhcount > 0), -1);
+
 		/* Add dependency info */
 		myself.classId = RelationRelationId;
 		myself.objectId = new_rel_oid;
@@ -1490,9 +1490,6 @@ RemoveAttributeById(Oid relid, AttrNumber attnum)
 		/* Remove any NOT NULL constraint the column may have */
 		attStruct->attnotnull = false;
 
-		/* We don't want to keep stats for it anymore */
-		attStruct->attstattarget = 0;
-
 		/*
 		 * Change the column name to something that isn't likely to conflict
 		 */
@@ -1514,8 +1511,9 @@ RemoveAttributeById(Oid relid, AttrNumber attnum)
 
 	heap_close(attr_rel, RowExclusiveLock);
 
+	/* Only drop pg_statistic entries for non system columns. */
 	if (attnum > 0)
-		RemoveStatistics(relid, attnum);
+		RemoveStatistics(relid, &attnum, 1);
 
 	relation_close(rel, NoLock);
 }
@@ -1740,7 +1738,7 @@ heap_drop_with_catalog(Oid relid)
 	/*
 	 * delete statistics
 	 */
-	RemoveStatistics(relid, 0);
+	RemoveStatistics(relid, NULL, 0);
 
 	/*
 	 * delete attribute tuples
@@ -2542,19 +2540,214 @@ cookConstraint(ParseState *pstate,
 
 
 /*
- * RemoveStatistics --- remove entries in pg_statistic for a rel or column
+ * AddStatistics --- add an entry in pg_statistic
+ *
+ * attnums		- an ordered array of AttrNumbers
+ * n_attnum		- number of elements in the array
+ * statistics_target	- the sampling size for this statistics
+ *
+ * Entries in pg_statistic are used by the planner to collect selectivity values.
+ * This function is called when a new relation is created or a new column is added
+ * to a relation. It is therefore ensured that every column has an entry during the
+ * lifetime of the relation since its creation. There is one exception from under
+ * this rule: thus function is a no-op during bootstrapping to avoid a catch-22
+ * situation where a pg_statistic entry would be created when pg_statistic itself
+ * doesn't exist yet. pg_statistic entries for system tables will be created by
+ * ANALYZE as before. The entry is created as invalid (stavalid == false) and
+ * the histogram columns are NULLs. This will also be fixed by ANALYZE.
+ */
+void
+AddStatistics(Oid relid, AttrNumber *attnums, int n_attnums, bool inherited, int statistics_target)
+{
+	Relation	rel;
+	ScanKeyData	scanKey[2];
+	SysScanDesc	scan;
+	int2vector *attnumvector;
+	HeapTuple	tuple;
+	TupleDesc	tupDesc;
+	Datum		values[Natts_pg_statistic];
+	bool		nulls[Natts_pg_statistic];
+	int		i, j;
+
+	if (IsBootstrapProcessingMode())
+		return;
+
+	Assert(attnums != NULL);
+	Assert(n_attnums > 0);
+
+	attnumvector = buildint2vector(attnums, n_attnums);
+
+	rel = heap_open(StatisticRelationId, RowExclusiveLock);
+
+	ScanKeyInit(&scanKey[0],
+					Anum_pg_statistic_starelid,
+					BTEqualStrategyNumber, F_OIDEQ,
+					ObjectIdGetDatum(relid));
+	ScanKeyInit(&scanKey[1],
+					Anum_pg_statistic_staattnums,
+					BTEqualStrategyNumber, F_ARRAY_EQ,
+					PointerGetDatum(attnumvector));
+
+	scan = systable_beginscan(rel, StatisticRelidAttnumsInhIndexId, true,
+									SnapshotNow, 2, scanKey);
+
+	tuple = systable_getnext(scan);
+	if (HeapTupleIsValid(tuple))
+	{
+		systable_endscan(scan);
+		elog(ERROR, "pg_statistic entry already exists for this table and set of columns");
+	}
+
+	systable_endscan(scan);
+
+	for (i = 0; i < Natts_pg_statistic; i++)
+		nulls[i] = true;
+
+	i = 0;
+	values[i] = ObjectIdGetDatum(relid);		nulls[i++] = false;	/* starelid */
+	values[i] = BoolGetDatum(inherited);		nulls[i++] = false;	/* stainherit */
+	values[i] = BoolGetDatum(false);		nulls[i++] = false;	/* stavalid */
+	values[i] = Int32GetDatum(statistics_target);	nulls[i++] = false;	/* statarget */
+	values[i] = Float4GetDatum(0);			nulls[i++] = false;	/* stanullfrac */
+	values[i] = Int32GetDatum(0);			nulls[i++] = false;	/* stawidth */
+	values[i] = Float4GetDatum(0);			nulls[i++] = false;	/* stadistinct */
+	for (j = 0; j < STATISTIC_NUM_SLOTS; j++)
+	{
+		values[i] = Int16GetDatum(0);		nulls[i++] = false;	/* stakindN */
+	}
+	for (j = 0; j < STATISTIC_NUM_SLOTS; j++)
+	{
+		values[i] = ObjectIdGetDatum(0);	nulls[i++] = false;	/* staopN */
+	}
+	values[i] = PointerGetDatum(attnumvector);	nulls[i++] = false;	/* stainherit */
+
+	tupDesc = RelationGetDescr(rel);
+
+	tuple = heap_form_tuple(tupDesc, values, nulls);
+
+	simple_heap_insert(rel, tuple);
+
+	CatalogUpdateIndexes(rel, tuple);
+
+	pfree(attnumvector);
+
+	relation_close(rel, RowExclusiveLock);
+}
+
+typedef struct invalidate_stats {
+	HeapTuple	tuple;
+	struct invalidate_stats *next;
+} invalidate_stats;
+
+/*
+ * InvalidateStatistics --- invalidate all pg_statistic entries of this attnum
+ *
+ * We need to collect copies of tuples that need invalidating in order not to
+ * conflict with the system table scan.
+ */
+void
+InvalidateStatistics(Oid relid, AttrNumber attnum)
+{
+	Relation		rel;
+	ScanKeyData		scanKey;
+	SysScanDesc		scan;
+	HeapTuple		tuple;
+	TupleDesc		tupDesc;
+	Form_pg_statistic	stattuple;
+	invalidate_stats   *tupptr;
+	invalidate_stats   *tupptr_next;
+	int			i;
+
+	if (IsBootstrapProcessingMode())
+		return;
+
+	rel = heap_open(StatisticRelationId, RowExclusiveLock);
+	tupDesc = RelationGetDescr(rel);
+
+	ScanKeyInit(&scanKey,
+					Anum_pg_statistic_starelid,
+					BTEqualStrategyNumber, F_OIDEQ,
+					ObjectIdGetDatum(relid));
+
+	scan = systable_beginscan(rel, StatisticRelidAttnumsInhIndexId, true,
+									SnapshotNow, 1, &scanKey);
+
+
+	tupptr = tupptr_next = NULL;
+	while (HeapTupleIsValid(tuple = systable_getnext(scan)))
+	{
+		bool	isnull;
+		Datum	attnvec;
+		int2vector *attnumvector;
+
+		attnvec = heap_getattr(tuple, Anum_pg_statistic_staattnums, tupDesc, &isnull);
+
+		Assert(!isnull);
+
+		attnumvector = (int2vector *) DatumGetPointer(attnvec);
+
+		for (i = 0; i < attnumvector->dim1; i++)
+		{
+			if (attnumvector->values[i] == attnum)
+			{
+				invalidate_stats *tmp;
+
+
+				tmp = palloc(sizeof(invalidate_stats));
+				tmp->tuple = heap_copytuple(tuple);
+				tmp->next = NULL;
+
+				if (tupptr == NULL)
+					tupptr = tupptr_next = tmp;
+				else
+				{
+					tupptr_next->next = tmp;
+					tupptr_next = tmp;
+				}
+
+				break; /* find next tuple */
+			}
+		}
+	}
+
+	systable_endscan(scan);
+
+	while (tupptr)
+	{
+		stattuple = (Form_pg_statistic) GETSTRUCT(tupptr->tuple);
+
+		stattuple->stavalid = false;
+
+		simple_heap_update(rel, &tupptr->tuple->t_self, tupptr->tuple);
+
+		CatalogUpdateIndexes(rel, tupptr->tuple);
+
+		tupptr_next = tupptr->next;
+
+		heap_freetuple(tupptr->tuple);
+		pfree(tupptr);
+
+		tupptr = tupptr_next;
+	}
+
+	relation_close(rel, RowExclusiveLock);
+}
+
+/*
+ * RemoveStatistics --- remove entries in pg_statistic for a rel's set of columns
  *
- * If attnum is zero, remove all entries for rel; else remove only the one(s)
- * for that column.
+ * If attnums is NULL, remove all entries for rel; else remove only the one
+ * for that set of column(s).
  */
 void
-RemoveStatistics(Oid relid, AttrNumber attnum)
+RemoveStatistics(Oid relid, AttrNumber *attnums, int n_attnums)
 {
 	Relation	pgstatistic;
 	SysScanDesc scan;
 	ScanKeyData key[2];
 	int			nkeys;
 	HeapTuple	tuple;
+	int2vector *attnumvector = NULL;
 
 	pgstatistic = heap_open(StatisticRelationId, RowExclusiveLock);
 
@@ -2563,18 +2756,19 @@ RemoveStatistics(Oid relid, AttrNumber attnum)
 				BTEqualStrategyNumber, F_OIDEQ,
 				ObjectIdGetDatum(relid));
 
-	if (attnum == 0)
+	if (attnums == NULL)
 		nkeys = 1;
 	else
 	{
+		attnumvector = buildint2vector(attnums, n_attnums);
 		ScanKeyInit(&key[1],
-					Anum_pg_statistic_staattnum,
-					BTEqualStrategyNumber, F_INT2EQ,
-					Int16GetDatum(attnum));
+					Anum_pg_statistic_staattnums,
+					BTEqualStrategyNumber, F_INT2VECTOREQ,
+					PointerGetDatum(attnumvector));
 		nkeys = 2;
 	}
 
-	scan = systable_beginscan(pgstatistic, StatisticRelidAttnumInhIndexId, true,
+	scan = systable_beginscan(pgstatistic, StatisticRelidAttnumsInhIndexId, true,
 							  SnapshotNow, nkeys, key);
 
 	/* we must loop even when attnum != 0, in case of inherited stats */
@@ -2583,6 +2777,9 @@ RemoveStatistics(Oid relid, AttrNumber attnum)
 
 	systable_endscan(scan);
 
+	if (attnumvector)
+		pfree(attnumvector);
+
 	heap_close(pgstatistic, RowExclusiveLock);
 }
 
diff --git a/src/backend/catalog/index.c b/src/backend/catalog/index.c
index bfbe642..74cfa58 100644
--- a/src/backend/catalog/index.c
+++ b/src/backend/catalog/index.c
@@ -342,7 +342,6 @@ ConstructTupleDescriptor(Relation heapRelation,
 			 */
 			to->attnum = i + 1;
 
-			to->attstattarget = -1;
 			to->attcacheoff = -1;
 			to->attnotnull = false;
 			to->atthasdef = false;
@@ -380,7 +379,6 @@ ConstructTupleDescriptor(Relation heapRelation,
 			to->attbyval = typeTup->typbyval;
 			to->attstorage = typeTup->typstorage;
 			to->attalign = typeTup->typalign;
-			to->attstattarget = -1;
 			to->attcacheoff = -1;
 			to->atttypmod = -1;
 			to->attislocal = true;
@@ -1353,7 +1351,7 @@ index_drop(Oid indexId)
 	 * them.
 	 */
 	if (hasexprs)
-		RemoveStatistics(indexId, 0);
+		RemoveStatistics(indexId, NULL, 0);
 
 	/*
 	 * fix ATTRIBUTE relation
diff --git a/src/backend/catalog/system_views.sql b/src/backend/catalog/system_views.sql
index ab594eb..62c4ce3 100644
--- a/src/backend/catalog/system_views.sql
+++ b/src/backend/catalog/system_views.sql
@@ -166,7 +166,7 @@ CREATE VIEW pg_stats AS
             WHEN stakind5 = 5 THEN stanumbers5
         END AS elem_count_histogram
     FROM pg_statistic s JOIN pg_class c ON (c.oid = s.starelid)
-         JOIN pg_attribute a ON (c.oid = attrelid AND attnum = s.staattnum)
+         JOIN pg_attribute a ON (c.oid = attrelid AND array_length(s.staattnums, 1) = 1 AND attnum = s.staattnums[0])
          LEFT JOIN pg_namespace n ON (n.oid = c.relnamespace)
     WHERE NOT attisdropped AND has_column_privilege(c.oid, a.attnum, 'select');
 
